ObjectArx 文本获取文字的实际宽度

作者: admin 分类: C++,CAD,ObjectARX 发布时间: 2022-04-19 19:30

转载:https://blog.csdn.net/qq_28742901/article/details/110794834

在给一个文本实体套一个图框的时候发现实体的宽度是固定的,并不是文字的实际占用尺寸

通过getGeomExtents获取到的坐标是实体的实际坐标,如果用这个结果框一个图框,可能会在框内留出比较多的空白空间,多行文本AcDbMText需要用actualWidth,单行文本AcDbText需要用到widthFactor。

/*!
 * @brief 获取文本实体真实宽度
 *
 * @param const AcDbObjectId& id 文本实体id
 * @return double 返回文本实体实际宽度,id所属实体不是文本实体返回0.0
 *
 * @author liujieda
 */
double getRealWidth(const AcDbObjectId& id)
{
    AcDbEntity * pEntity;
    Acad::ErrorStatus es = acdbOpenAcDbEntity(pEntity, id, AcDb::kForRead);
 
    double width = 0.0;
    if (pEntity->isA() == AcDbMText::desc())
    {
        AcDbMText *pMText = AcDbMText::cast(pEntity);
        width = pMText->actualWidth();
    }
    else if (pEntity->isA() == AcDbText::desc())
    {
        AcDbText *pText = AcDbText::cast(pEntity);
        width = pText->widthFactor();
    }
    return width;
}

发表评论

您的电子邮箱地址不会被公开。

标签云